package canchasadmon.business;

import canchasadmon.dao.UsuarioDAO;
import canchasadmon.dao.UsuarioDAOImpl;
import canchasadmon.vo.UsuarioVO;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;



public class UsuarioBusinessImpl implements UsuarioBusiness {

	private UsuarioDAO usuarioDAO = UsuarioDAOImpl.getInstance();
	
	private UsuarioBusinessImpl() {}	
	
	private static class Holder {
		private static final UsuarioBusiness INSTANCE = new UsuarioBusinessImpl();
    }

    public static UsuarioBusiness getInstance() {
        return Holder.INSTANCE;
    }
    
    /* (non-Javadoc)
	 * @see negocio.UsuarioNegocio#listar()
	 */
    @Override
    public synchronized List<UsuarioVO> listar() {    	
    	
    	return usuarioDAO.listar();
    	
    }
   
	/* (non-Javadoc)
	 * @see negocio.UsuarioNegocio#login(java.lang.String, byte[])
	 */
	@Override
	public UsuarioVO login(String nombreUsuario, byte[] contrasenya) {
    	
    	UsuarioVO usuarioVO = null;
    	boolean encontrado = false;
    	
    	List<UsuarioVO> usuarios = usuarioDAO.listar();
    	
    	Iterator<UsuarioVO> usuariosIterator = usuarios.iterator();
    	String w = new String(contrasenya);
    	while(usuariosIterator.hasNext() && !encontrado) {
    		
    		usuarioVO = usuariosIterator.next();
    		String s = new String(usuarioVO.getContrasenya());
    		boolean t = Arrays.equals(usuarioVO.getContrasenya(),contrasenya);
    		encontrado = usuarioVO.getNombreUsuario().equals(nombreUsuario) && Arrays.equals(usuarioVO.getContrasenya(),contrasenya);
    		
    	}

    	return !encontrado ? null : usuarioVO;
    	
    }
		
	/* (non-Javadoc)
	 * @see negocio.UsuarioNegocio#agregar(vo.UsuarioVO)
	 */
	@Override
	public synchronized void agregar(UsuarioVO usuario) throws Exception {
    	
            UsuarioVO usuarioVO = null;  	

            List<UsuarioVO> usuarios = usuarioDAO.listar();
                        
            if(null != usuario.getId()) {
                
                usuario = usuarioDAO.actualizar(usuario);
            
            }else {

            for (int i = 0; i < usuarios.size(); i++) {

                usuarioVO = usuarios.get(i);

                if (usuarioVO.getNombreUsuario().equals(usuario.getNombreUsuario()) && usuarioVO.getNombre().equals(usuario.getNombre())) {

                        throw new Exception("El usuario ya se encuentra registrado");

                } 

            }    			    	

            usuario = usuarioDAO.agregar(usuario);
            }
        	
    }
	
	
	/* (non-Javadoc)
	 * @see negocio.UsuarioNegocio#eliminar(java.lang.String, java.lang.String)
	 */
	@Override
	public synchronized boolean eliminar(String nombre, String nombreUsuario) {
		
		return usuarioDAO.eliminar(nombre, nombreUsuario);
		
	}
	
	
}
