package canchasadmon.vo;

import canchasadmon.common.TipoUsuario;
import java.io.Serializable;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;


public class UsuarioVO implements Serializable {

	private static final long serialVersionUID = 1668344436254893903L;
	
	private Long id;
	private String nombre;
	private String apellidoPaterno;
	private String apelidoMaterno;
	private String nombreUsuario;
	private byte[] contrasenya;
	private TipoUsuario tipoUsuario;
	private Date fechaRegistro;
	private Date fechaBaja;

    public UsuarioVO() {
    }

	public UsuarioVO(String nombreUsuario, String nombre, String apellidoPaterno, String apelidoMaterno, byte[] contrasenya, TipoUsuario tipoUsuario) {		
		this.nombreUsuario = nombreUsuario;
		this.nombre = nombre;
		this.apellidoPaterno = apellidoPaterno;
		this.apelidoMaterno = apelidoMaterno;
		this.contrasenya = contrasenya;
		this.tipoUsuario = tipoUsuario;
		
		Calendar calendar = Calendar.getInstance(new Locale("es-CO"));
		this.fechaRegistro = calendar.getTime();
		
	}
			
	public UsuarioVO(String login, String nombre, String apellidoPaterno, byte[] contrasenya) {		
		this(login, nombre, apellidoPaterno, null, contrasenya, TipoUsuario.NORMAL);		
	}
				
	public UsuarioVO(String login, String nombre, String apellidoPaterno, byte[] contrasenya, TipoUsuario tipoUsuario) {		
		this(login, nombre, apellidoPaterno, null, contrasenya, tipoUsuario);	
	}
	
	public UsuarioVO(String login, String nombre, String apellidoPaterno, String apelidoMaterno, byte[] contrasenya) {		
		this(login, nombre, apellidoPaterno, apelidoMaterno, contrasenya, TipoUsuario.NORMAL);
	}
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getApellidoPaterno() {
		return apellidoPaterno;
	}

	public void setApellidoPaterno(String apellidoPaterno) {
		this.apellidoPaterno = apellidoPaterno;
	}

	public String getApelidoMaterno() {
		return apelidoMaterno;
	}

	public void setApelidoMaterno(String apelidoMaterno) {
		this.apelidoMaterno = apelidoMaterno;
	}

	public byte[] getContrasenya() {
		return contrasenya;
	}

	public void setContrasenya(byte[] contrasenya) {
		this.contrasenya = contrasenya;
	}

	public TipoUsuario getTipoUsuario() {
		return tipoUsuario;
	}

	public void setTipoUsuario(TipoUsuario tipoUsuario) {
		this.tipoUsuario = tipoUsuario;
	}

	public Date getFechaRegistro() {
		return fechaRegistro;
	}

        public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro=fechaRegistro;
	}
        
	public Date getFechaBaja() {
		return fechaBaja;
	}

	public void setFechaBaja(Date fechaBaja) {
		this.fechaBaja = fechaBaja;
	}

	public String getNombreUsuario() {
		return nombreUsuario;
	}

	public void setNombreUsuario(String nombreUsuario) {
		this.nombreUsuario = nombreUsuario;
	}

	@Override
	public String toString() {
		return "UsuarioVO [id=" + id + ", nombre=" + nombre + ", apellidoPaterno=" + apellidoPaterno
				+ ", apelidoMaterno=" + apelidoMaterno + ", nombreUsuario=" + nombreUsuario + ", contrasenya="
				+ Arrays.toString(contrasenya) + ", tipoUsuario=" + tipoUsuario + ", fechaRegistro=" + fechaRegistro
				+ ", fechaBaja=" + fechaBaja + "]";
	}

}
